#include<bits/stdc++.h>
using namespace std;

const int MAXX = 3e5 + 7;

vector < vector <int> > gr;
int vals[MAXX];
bool used[MAXX];

void dijkstra(int start, int endd)
{
    if (used[endd])
        return;

    used[start] = true;

    for (int i : gr[start])
        if (!used[i] && (!vals[i] || vals[i] > vals[start] + 1))
        {
            vals[i] = vals[start] + 1;
            dijkstra(i, endd);
        }
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;

    gr.resize(n + 1, {});

    for (int i = 0; i < m; i++)
    {
        int u, v;
        char c;
        cin >> u >> v >> c;

        gr[u].push_back(v);
        //gr[v].push_back(u);
    }

    dijkstra(1, n);

    while(vals[n]--)
        cout << 'a';

    cout << endl;
}
