


#include <bits/stdc++.h>
using namespace std;

vector<pair<int,char>> edges[300000];
vector<pair<int,char>> edges2[300000];
int depth[300001];
int visited[300001];

void bfs(int start)
{
    queue<pair<int,int>> q;
    q.push({start,1});
    while(!q.empty())
    {
        auto cur=q.front();
        depth[cur.first]=cur.second;
        q.pop();
        for(auto child:edges[cur.first])
        {
            if(depth[child.first]<=cur.second&&depth[child.first]!=0)continue;
            q.push({child.first,cur.second+1});
        }
    }

}

bool compare(pair<int,char> left ,pair<int,char> right)
{
    return left.second<right.second;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    auto cmp = [](pair<string,int> lleft, pair<string,int> rright) {
    if(lleft.first.size()!=rright.first.size())
    {
        return lleft.first.size()>rright.first.size();
    }
    else
    {
        return lleft.first>rright.first;
    }
    };

    priority_queue<pair<string,int>,
    vector<pair<string,int>>
    ,decltype(cmp)>
    pq(cmp);
    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int a,b;
        char c;
        cin>>a>>b>>c;
        edges[a-1].push_back({b-1,c});
        edges[b-1].push_back({a-1,c});
    }

    bfs(0);
    for(int i=0;i<n;i++)
    {
        //cout<<depth[i]<<" ";
    }

    for(int i=0;i<n;i++)
    {
        for(auto a: edges[i])
        {
            if(depth[i]-depth[a.first]==-1)
            {
                edges2[i].push_back(a);
            }
        }
        sort(edges2[i].begin(),edges2[i].end(),compare);
        //cout<<"i:"<<i<<" ";
        /*
        for(auto a : edges2[i])
        {
            cout<<a.first<<" "<<a.second<<" ";
        }
        cout<<endl;
        */

    }

        int next=0;

    pq.push({"\0",0});
    string ans;
    while(!pq.empty())
    {
        auto current=pq.top();
        if(current.second==n-1)
        {
            ans=current.first;
            break;
        }
        pq.pop();
        if(visited[current.second]==1)continue;
        visited[current.second]=1;
        for(auto child :edges2[current.second])
        {
            if(visited[child.first]==1)continue;
            string tmps;
            tmps=current.first;
            tmps+=child.second;
            pq.push({tmps,child.first});
        }
    }
    cout<<ans;


    return 0;
}
