#include<bits/stdc++.h>
using namespace std;

const int MAXX = 3e5 + 7;

vector <  pair <int, int> > gr[MAXX];
int vals[MAXX];
bool used[MAXX];

void bfs(int i, int end)
{
    if (i == end)
        return;

    for (pair <int, int> j : gr[i])
        if ((vals[j.first] == 0 || vals[j.first] > vals[i] + j.second))
            vals[j.first] = vals[i] + j.second;

    for (pair <int, int> j : gr[i])
        bfs(j.first, end);
}

bool cmp(pair <int, int > &a, pair <int, int> &b)
{
    if (a.second >= b.second)
        return false;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; i++)
    {
        int u, v;
        char c;

        cin >> u >> v >> c;

        gr[u].push_back({v, c - 'a' + 1});

        sort(gr[u].begin(), gr[u].end(), cmp);
    }

    bfs(1, n);

    for (int i = 0; i < vals[n]; i++)
        cout << 'a';

    cout << endl;
}
