#include<bits/stdc++.h>
using namespace std;
const long long MAXN = 300007, MAXM = 600007, INF = 1<<28;
vector<int> g[MAXN];
long long dist[MAXN];
int n,m;
void Dijkstra(){
    priority_queue<pair<int,int>> pq;
    for(int i = 0 ; i <= n ; i++) dist[i] = INF;
    dist[1] = 0;
    pq.push({0,1});
    int v;
    int u;
    int d;
    while(!pq.empty()){
        v = pq.top().second;
        d = -pq.top().first;
        pq.pop();
        //cout<<"v = "<<v<<" "<<d<<endl;
        if(d > dist[v]) continue;
        dist[v] = d;
        for(int i = 0 ; i < g[v].size() ; i++){
            u = g[v][i];
            //cout<<"u = "<<u<<" "<<"dist = "<<dist[u];
            if(d + 1 < dist[u]){
                dist[u] = d+1;
                pq.push({-dist[u],u});
                //cout<<"changed to "<<dist[u];
            }
            cout<<endl;
        }
    }

}
int main(){
    cin>>n>>m;
    char c;
    int u,v;
    for(int i = 0 ; i < m ; i++){
        cin>>u>>v>>c;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    Dijkstra();
    for(int i = 0 ; i < dist[n] ; i++) cout<<'a';
}
